import * as mc from "@minecraft/server"

let isTP = false
let playerTpName
let time = 0
let playerInNorthPole

let entityToChangeMode
let mode = false
let modetime = 0

mc.world.events.blockBreak.subscribe((brokenBlock) => {
    if (brokenBlock.brokenBlockPermutation.type.id == "np:christmas_tree") {
        let blockLoc = new mc.Location(brokenBlock.block.location.x, brokenBlock.block.location.y, brokenBlock.block.location.z)
        
        mc.world.getDimension(brokenBlock.dimension.id).runCommandAsync("execute if block " + blockLoc.x + " " + (blockLoc.y + 2) + " " + blockLoc.z + " np:christmas_tree run setblock " + blockLoc.x + " " + (blockLoc.y + 2) + " " + blockLoc.z + " air")
        mc.world.getDimension(brokenBlock.dimension.id).runCommandAsync("execute if block " + blockLoc.x + " " + (blockLoc.y + 1) + " " + blockLoc.z + " np:christmas_tree run setblock " + blockLoc.x + " " + (blockLoc.y + 1) + " " + blockLoc.z + " air")
        mc.world.getDimension(brokenBlock.dimension.id).runCommandAsync("execute if block " + blockLoc.x + " " + (blockLoc.y - 1) + " " + blockLoc.z + " np:christmas_tree run setblock " + blockLoc.x + " " + (blockLoc.y - 1) + " " + blockLoc.z + " air")
        mc.world.getDimension(brokenBlock.dimension.id).runCommandAsync("execute if block " + blockLoc.x + " " + (blockLoc.y - 2) + " " + blockLoc.z + " np:christmas_tree run setblock " + blockLoc.x + " " + (blockLoc.y - 2) + " " + blockLoc.z + " air")
    }
})

mc.world.events.itemUseOn.subscribe((interact) => {
    playerInNorthPole = interact.source
    let block = mc.world.getDimension(interact.source.dimension.id).getBlock(interact.blockLocation)
    if (block.typeId == "np:christmas_tree") {
        if (
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x - 1, block.location.y, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y, block.location.z - 1)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x + 1, block.location.y, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y, block.location.z + 1)).typeId == "np:gift_box"
        ) {
            travel(interact.source.nameTag)
        }

        if (
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x - 1, block.location.y - 1, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y - 1, block.location.z - 1)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x + 1, block.location.y - 1, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y - 1, block.location.z + 1)).typeId == "np:gift_box"
        ) {
            travel(interact.source.nameTag)
        }

        if (
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x - 1, block.location.y - 2, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y - 2, block.location.z - 1)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x + 1, block.location.y - 2, block.location.z)).typeId == "np:gift_box" &&
            mc.world.getDimension(interact.source.dimension.id).getBlock( new mc.BlockLocation(block.location.x, block.location.y - 2, block.location.z + 1)).typeId == "np:gift_box"
        ) {
            travel(interact.source.nameTag)
        }
    }
})

mc.world.events.entityHurt.subscribe((entity) => {
    if (entity.hurtEntity.typeId == "minecraft:player") {
        if (entity.hurtEntity.getComponent("minecraft:health").current < 0.5) {
            entityToChangeMode = entity.hurtEntity.nameTag
            mode = true
        }
    }
})

mc.world.events.tick.subscribe(() => {
    if (isTP) {
        mc.world.getDimension("the end").runCommandAsync("gamerule sendcommandfeedback false")
        mc.world.getDimension("the end").runCommandAsync("tp "+ playerTpName +" 10022 152 11")
        mc.world.getDimension("the end").runCommandAsync("effect "+ playerTpName +" blindness 2 2 true")
        mc.world.getDimension("the end").runCommandAsync("gamerule keepinventory true")
        mc.world.getDimension("the end").runCommandAsync("gamerule domobspawning false")
        mc.world.getDimension("the end").runCommandAsync("gamemode adventure "+playerTpName)

        time++
        if (time == 100) {
            firstGenTerrain()
            isTP = false
            time = 0
        }
    }

    if (mode) {
        mc.world.getDimension("the end").runCommandAsync("gamemode survival "+entityToChangeMode)
        mc.world.getDimension("the end").runCommandAsync("gamerule keepinventory false")
        mc.world.getDimension("the end").runCommandAsync("gamerule domobspawning true")
        modetime++;
        if (modetime > 100) {
            mode = false
            modetime = 0
        }
    }
})

function travel(playerName) {
    playerTpName = playerName
    isTP = true
}

function firstGenTerrain() {
    if (mc.world.getDimension("the end").getBlock(new mc.BlockLocation(10000, 149, 0)).typeId != "minecraft:bedrock") {
        mc.world.getDimension("the end").runCommandAsync("structure load mystructure:house 10000 150 0")
        mc.world.getDimension("the end").runCommandAsync("setblock 10000 149 0 minecraft:bedrock")
    }
}